'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.identify = identify;

var _parser = require('./parser');

/**
 * Identifier
 */
function identify(query) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var isStrict = typeof options.strict === 'undefined' ? true : options.strict;

  var result = (0, _parser.parse)(query, isStrict);

  return result.body.map(function (statement) {
    return {
      start: statement.start,
      end: statement.end,
      text: query.substring(statement.start, statement.end + 1),
      type: statement.type,
      executionType: statement.executionType
    };
  });
}